

#   if {![info exists ::R3B]} {return}

#   if {![info exists ::R3B::ModuleMenu]} {set ::R3B::ModuleMenu [list localhost]}
#   if {![info exists ::R3B::R3B4K]} {set ::R3B::R3B4K [first $::R3B::ModuleMenu]}



    proc ReadR3BRegister {Addr}  {
        global errorCode errorInfo
        global MIDAS_XR3BAccessServer_Exists
        global XR3BAccessServerHost

 puts "ReadR3BRegister  Addr=[format \"0x%x\" $Addr]"
# return 0

        if {[info exists MIDAS_XR3BAccessServer_Exists]} {
 puts "ReadR3BRegister do_Get"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XR3BAccessServer do_Get $Addr} m]
        } else {
            if {$XR3BAccessServerHost != $::R3B::R3B4K} {
                set XR3BAccessServerHost  $::R3B::R3B4K
 puts "ReadR3BRegister configure $XR3BAccessServerHost"
                XR3BAccessClient_Configure
            }
 puts "ReadR3BRegister  $XR3BAccessServerHost  XR3BAccessClient__Get"
            set rc [catch {XR3BAccessClient__Get $Addr} m]
        }
        if {$rc != 0} {
#            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
  puts "ReadR3BRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
  puts "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc WriteR3BRegister {Addr Vl}  {
        global errorCode errorInfo
        global MIDAS_XR3BAccessServer_Exists
        global XR3BAccessServerHost

 puts "WriteR3BRegister  Vl=[format \"0x%x\" $Vl]  Addr=[format \"0x%x\" $Addr]"
# return 0

        if {[info exists MIDAS_XR3BAccessServer_Exists]} {
 puts "WriteR3BRegister do_Set"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XR3BAccessServer do_Set $Addr $Vl} m]
        } else {
            if {$XR3BAccessServerHost != $::R3B::R3B4K} {
                set XR3BAccessServerHost  $::R3B::R3B4K
 puts "WriteR3BRegister configure $XR3BAccessServerHost"
                XR3BAccessClient_Configure
            }
 puts "WriteR3BRegister XR3BAccessClient__Set"
            set rc [catch {XR3BAccessClient__Set $Addr $Vl} m]
        }
        if {$rc != 0} {
#            InsertLog "Set returned with an error\n$m\n$errorCode\n$errorInfo"
            puts "WriteR3BRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            puts "WriteR3BRegister Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

