

   Setting BGColor "BlanchedAlmond"
   Setting TextColor "red"

  Setting ProjectName AGATA
  Setting ProjectImage agata_banner.png

  Setting Option1Name STFC
  Setting Option1URL  "stfc.ac.uk"
  Setting Option1Image stfc.jpg


global MessageLoggerServerHost
  set  MessageLoggerServerHost localhost

global MIDAS_MessageLoggerServer_UseElog MIDAS_MessageLoggerServer_ElogCmd
global MessageLoggerClient__TimeOut

# set MessageLoggerClient__TimeOut 7000

set MIDAS_MessageLoggerServer_UseFile 1     ;#    no write to /MIDAS/log
set MIDAS_MessageLoggerServer_UseELog 0     ;#    send to ELog
set MIDAS_MessageLoggerServer_ElogCmd [file join $env(MIDASBASE) config TclHttpd  Elog]

  package require MessageLoggerServer

after 1000   ;# allow Message Logger to start

    package require  MessageLoggerClient 

  Setting Option2Name "Elog Server"
  Setting Option2URL  "http://run-control:8989/Slow Control"

    upvar #0 AGATADigitizerAccessServer_Server AGATADigitizerServer
    set AGATADigitizerServer digitizer1-sc

    upvar #0 AGATADigitizerAccessServer_ConfigFile ConfigFile
    upvar #0 AGATADigitizerAccessServer_LayoutFile LayoutFile

    set ConfigFile [file join $env(MIDASBASE) config TclHttpd  AGATADigitizerConfig.tcl]
    set LayoutFile [file join $env(MIDASBASE) config TclHttpd  AGATADigitizerLayout.tcl]

    upvar #0 AGATADigitizerAccessServer_MaxDigitizer MaxDigitizer
    set MaxDigitizer 30
    
    upvar #0 AGATADigitizerAccessServer_DBRootName RootName
    upvar #0 AGATADigitizerAccessServer_DBNodeBase NodeBase

    set RootName EXPERIMENTS
    set NodeBase AGATA/Digitizers/2010

    package require AGATADigitizerAccessServer

    package require  AGATADigitizerRunControl


    Setting DataBaseRoot "/MIDAS/DB"

    package require DataBaseAccessServer

 
  Setting Option3Name "Digitiser Firmware Home Page"
  Setting Option3URL  "http://npg.dl.ac.uk/AGATA/Digitiser"

  Setting Option4Name "Server Software Home Page"
  Setting Option4URL  "http://npg.dl.ac.uk/MIDAS/download/WebServices.html"
