
#    MIDAS Access Client  for Rsh service

package require MIDASAccessClient   ;#   load default support procedures

global RshServerHost RshServerPort

if {[info exists RshServerHost] == 0} then {set RshServerHost localhost}
if {[info exists RshServerPort] == 0} then {set RshServerPort 8015}

variable uri "urn:RshServer"
variable proxy "http://$RshServerHost:$RshServerPort/RshServer"

proc RshClient_Configure {} {
   global  RshServerHost RshServerPort
   variable proxy

   set proxy "http://$RshServerHost:$RshServerPort/RshServer"

   foreach method [info procs RshClient__*] {catch {SOAP::configure $method -proxy $proxy}}
}

SOAP::create RshClient__Rsh -proxy $proxy -uri $uri -timeout 5000  \
     -name Rsh \
     -params {p string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 


package provide RshClient 1.0
