



   proc ReadNetVar {Name} {
       global errorCode errorInfo
       variable Rmsg

       set z [catch {::namespace inscope ::urn:NetVarService ReadRegister $Name} Rmsg]

       if {$z == 0} {
           set rc [lindex $Rmsg 5]
# InsertLog "ReadRegister $Name returned $rc  [format 0x%x $rc]"
#           InsertLog "ReadRegister $Name returned $rc  [format 0x%x $rc]"
       } else {
           InsertLog "ReadRegister failed: Name=$Name; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $rc
   }

   proc WriteNetVar {Name Data} {
       global errorCode errorInfo
       variable Wmsg

# InsertLog "WriteRegister $Name $Data [format 0x%x $Data]"
       set z [catch {::namespace inscope ::urn:NetVarService WriteRegister $Name $Data} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteRegister $Name $Data [format 0x%x $Data] returned: [lindex $Wmsg 5]"
#           InsertLog "WriteRegister $Name $Data [format 0x%x $Data]"
       } else {
           InsertLog "WriteRegister failed: Name=$Name; Data=$Data; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
   }

   proc CreateNetVar {Name Opts} {
       global errorCode errorInfo
       variable Wmsg

       set z [catch {::namespace inscope ::urn:NetVarService DefineRegister  $Name NetVar $Opts} Wmsg]

       if {$z == 0} {
#           InsertLog "DefineRegister returned: [lindex $Wmsg 5]"
           set errorCode 0
       } else {
           InsertLog "DefineRegister failed: Name=$Name; Opts=$Opts; Code= $errorCode; Info= [first [split $errorInfo \n]]"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
       }
       return $errorCode
   }
